# Copyright 2008  Canonical, Ltd
# Author: Brian Murray <brian@ubuntu.com>
# License: GPLv2

from storm.locals import *

class Package(object):
    __storm_table__ = "sourcepackage"
    id = Int(primary=True)
    name = Unicode()

    def __init__(self, name):
        self.name = name

class Statistic(object):
    __storm_table__ = "pkg_bug_stat"
    id = Int(primary=True)
    pkgid = Int()
    time = Int()
    total = Int()
    new = Int("fresh")
    incomplete = Int()
    incomplete_w = Int()
    incomplete_wo = Int()
    confirmed = Int()
    triaged = Int()
    inprogress = Int()
    fixcommitted = Int()
    fixreleased = Int()
    invalid = Int()
    wontfix = Int()
    total_undecided = Int()
    total_wishlist = Int()
    total_low = Int()
    total_medium = Int()
    total_high = Int()
    total_critical = Int()
    open_undecided = Int()
    open_wishlist = Int()
    open_low = Int()
    open_medium = Int()
    open_high = Int()
    open_critical = Int()
    total_apportcrash = Int()
    open_apportcrash = Int()
    total_apportbug = Int()
    open_apportbug = Int()
    total_apportpackage = Int()
    open_apportpackage = Int()
    total_haspatch = Int()
    open_haspatch = Int()
    duplicates = Int()

    def __init__(self, pkgid, time, total, new, incomplete, incomplete_w, incomplete_wo, confirmed, triaged, inprogress, fixcommitted, fixreleased, invalid, wontfix, total_undecided, total_wishlist, total_low, total_medium, total_high, total_critical, open_undecided, open_wishlist, open_low, open_medium, open_high, open_critical, total_apportcrash, open_apportcrash, total_apportbug, open_apportbug, total_apportpackage, open_apportpackage, total_haspatch, open_haspatch, duplicates):
        self.pkgid = pkgid
        self.time = time
        self.total = total
        self.new = new
        self.incomplete = incomplete
        self.incomplete_w = incomplete_w
        self.incomplete_wo = incomplete_wo
        self.confirmed = confirmed
        self.triaged = triaged
        self.inprogress = inprogress
        self.fixcommitted = fixcommitted
        self.fixreleased = fixreleased
        self.invalid = invalid
        self.wontfix = wontfix
        self.total_undecided = total_undecided 
        self.total_wishlist = total_wishlist
        self.total_low = total_low
        self.total_medium = total_medium
        self.total_high = total_high
        self.total_critical = total_critical
        self.open_undecided = open_undecided
        self.open_wishlist = open_wishlist
        self.open_low = open_low
        self.open_medium = open_medium
        self.open_high = open_high
        self.open_critical = open_critical
        self.total_apportcrash = total_apportcrash
        self.open_apportcrash = open_apportcrash
        self.total_apportbug = total_apportbug
        self.open_apportbug = open_apportbug
        self.total_apportpackage = total_apportpackage
        self.open_apportpackage = open_apportpackage
        self.total_haspatch = total_haspatch
        self.open_haspatch = open_haspatch
        self.duplicates = duplicates
