#!/usr/bin/env python
######################################################################
# automatically generate a html page which lists kernel bugs the
# kernel team might want to look at:
#
# http://qa.ubuntu.com/reports/ogasawara/kernel-buglist-by-team.html
#
# this script requires that you pass in a separate file containing
# the list of bugs.  The list must be in the following format:
#
# <bug number>,<comment>,<ommit>,
#
# for example:
# 112233,kernel config change,,
# 445566,patch upstream,,
# 0,end of the current week's bug list,,
# 778899,bitesize patch,,
# 92953,test bug,ommit,
#
# The resulting display will be sorted by Importance and then
# subsorted by Status.  Bugs which come after the line
# "0,end of the current week's bug list,," will automatically fall
# under the Carried Forward section unless the "ommit" string is
# specified in the 3rd field.
######################################################################
import time
import commands
import inspect
import sys, os, re
import KernelBugListByTeam
import BugList

if __name__ == "__main__":
    if len(sys.argv) != 2:
        print "Usage: %s <buglist.txt>" % (sys.argv[0])
        sys.exit(1)

    list = KernelBugListByTeam.KernelBugList()
    (buglist_data, stats) = list.Create()

    html = list.GenerateStatsHTML(stats)
    html += list.GenerateHTML(buglist_data)
    list.WriteFile(html)
