#!/usr/bin/env python
######################################################################
# automatically generate a text page which lists kernel bugs the
# kernel team might want to look at based on tag:
#
# 
#
# this script requires that you provide a tag to search based on
#
# Usage: list-tag.py <package> <tag>, <comment>, <filename>
#
# Revision history:
#   Date:                     Description:        Dev:
#  Dec. 8, 2010    Initially Created     apw
# 
######################################################################

import sys
from lpltk.service                   import LaunchpadService
from datetime                        import datetime

# lpTags
#
class lpTags():
    # main
    #
    
    def main(self, package, tag, comment, filename):
        lp = LaunchpadService()
        distro         = lp.distributions['ubuntu']
        source_package = distro.get_source_package(package)
        search_tags            = [tag]
        search_tags_combinator = "All"
        search_status          = ['Triaged', 'New', 'Confirmed', 'In Progress', 'Incomplete', 'Fix Committed']
        tasks = source_package.search_tasks(tags=search_tags, status=search_status)

        with open(filename, "w") as f:
            for task in tasks:
                bug = task.bug
	        f.write("%s,%s,\n" % (bug.id, comment))
                print(bug.id)

if __name__ == '__main__':
    if len(sys.argv) != 5:
        print "Usage:list-tag <package> <tag>, <comment>, <filename>"
        sys.exit(1)

    app = lpTags()
    app.main(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])

# vi:set ts=4 sw=4 expandtab:

