#!/usr/bin/python
#
# read a bug stat csv file and present stats, on open bugs, for now and a while ago
# where a while ago is defined by a period in days

import datetime
import csv
import urllib

def present_results(date, stats):
    open = 0
    data = []
    stati = ['New', 'Incomplete', 'Confirmed', 'Triaged', 'In Progress', 'Fix Committed']
    data.append('%s' % date)
    for k,v in stats.items():
        open += int(v)
    for status in stati:
        data.append('%s: %s' % (status, stats[status]))
    data.insert(1, 'Open: %s' % open)
    print ', '.join(data)

period = 189 
# this is the number of days in the release cycle is as near as I could figure
# I looked at the difference in days between Jaunty and Karmic for Alpha 6 and Beta

today = datetime.date.today()

awhileago = today - datetime.timedelta(days=period)

datafile = "http://people.canonical.com/~brian/complete-graphs/regression-potential/regression-potential.data"

try:
    reader = csv.reader(urllib.urlopen(datafile))
except IOError:
    print '''data file doesn't exist'''

oldstats = {}
currentstats = {}

for row in reader:
    if row[0].startswith('#'):
        continue
    if datetime.date.fromtimestamp(int(row[0])) == awhileago:
        oldstats = { 'New':row[2].strip(), 'Incomplete':row[3].strip(), 'Confirmed':row[4].strip(), 'Triaged':row[5].strip(), 'In Progress':row[6].strip(), 'Fix Committed':row[7].strip() } # not using append only want the last stat for that day
    elif datetime.date.fromtimestamp(int(row[0])) == today:
        currentstats = { 'New':row[2].strip(), 'Incomplete':row[3].strip(), 'Confirmed':row[4].strip(), 'Triaged':row[5].strip(), 'In Progress':row[6].strip(), 'Fix Committed':row[7].strip() } # not using append only want the last stat for that day

present_results(awhileago, oldstats)
present_results(today, currentstats)
