#!/usr/bin/python
# this script will parse the html launchpad bug pages for a repository and return quantities of bugs
# very fragile but much faster than trying to count all the ones in main with bugnumbers

import urllib
import time
import re

repository = { 'main':'1',
               'restricted':'2',
               'universe':'3',
               'multiverse':'4',
               'contrib':'5',
               'non-free':'6',
               'partner':'7' }

# %3A is :

for repo in repository.keys():

    data = ['%d' % int(time.time())]
    datafile = open('/home/brian/public_html/complete-graphs/repository/%s/%s.data' % (repo, repo), 'a')
    total_url = 'https://bugs.launchpad.net/ubuntu/+bugs?field.searchtext=&orderby=-importance&field.status%3Alist=NEW&field.status%3Alist=INCOMPLETE_WITH_RESPONSE&field.status%3Alist=INCOMPLETE_WITHOUT_RESPONSE&field.status%3Alist=INVALID&field.status%3Alist=WONTFIX&field.status%3Alist=CONFIRMED&field.status%3Alist=TRIAGED&field.status%3Alist=INPROGRESS&field.status%3Alist=FIXCOMMITTED&field.status%3Alist=FIXRELEASED&assignee_option=any&field.assignee=&field.bug_reporter=&field.bug_contact=&field.bug_commenter=&field.subscriber=' + '&field.component=%s' % (repository[repo]) + '&field.component-empty-marker=1&field.status_upstream-empty-marker=1&field.omit_dupes.used=&field.omit_dupes=on&field.has_patch.used=&field.tag=&field.has_cve.used=&field.has_no_package.used=&search=Search'  

    try: 
        total_repo_url = urllib.urlopen('%s' % (total_url) ).read()
        if re.search(r'.*No\s+results\s+for\s+search.*', total_repo_url, re.MULTILINE):
            total_repo_number = '0'
        else: 
            total_repo_number = re.findall(r'.*of\s+(\d+)\s+results.*', total_repo_url, re.MULTILINE)[0]
        data.append(total_repo_number)
    except:
        datafile.write('#%s Launchpad is down\n' % int(time.time()))
        datafile.close()
        continue
    #print 'Total in %s: %s' % (repo, total_repo_number)

    status_url = 'https://bugs.launchpad.net/ubuntu/+bugs?field.searchtext=&orderby=-importance&assignee_option=any&field.assignee=&field.bug_reporter=&field.bug_contact=&field.bug_commenter=&field.subscriber=' + '&field.component=%s' % (repository[repo]) + '&field.component-empty-marker=1&field.status_upstream-empty-marker=1&field.omit_dupes.used=&field.omit_dupes=on&field.has_patch.used=&field.tag=&field.has_cve.used=&field.has_no_package.used=&search=Search' 

    importance_url = 'https://bugs.launchpad.net/ubuntu/+bugs?field.searchtext=&orderby=-importance&field.status%3Alist=NEW&field.status%3Alist=INCOMPLETE_WITH_RESPONSE&field.status%3Alist=INCOMPLETE_WITHOUT_RESPONSE&field.status%3Alist=INVALID&field.status%3Alist=WONTFIX&field.status%3Alist=CONFIRMED&field.status%3Alist=TRIAGED&field.status%3Alist=INPROGRESS&field.status%3Alist=FIXCOMMITTED&field.status%3Alist=FIXRELEASED&assignee_option=any&field.assignee=&field.bug_reporter=&field.bug_contact=&field.bug_commenter=&field.subscriber=' + '&field.component=%s' % (repository[repo]) + '&field.component-empty-marker=1&field.status_upstream-empty-marker=1&field.omit_dupes.used=&field.omit_dupes=on&field.has_patch.used=&field.tag=&field.has_cve.used=&field.has_no_package.used=&search=Search'

    for status in ('New', 'INCOMPLETE_WITH_RESPONSE&field.status:list=INCOMPLETE_WITHOUT_RESPONSE', 'Confirmed', 'Triaged', 'In+Progress', 'Fix+Committed', 'Fix+Released', 'Invalid', '''Won't+Fix'''):
        repo_status_url = urllib.urlopen('''%s&field.status:list=%s''' % (status_url, status) ).read()
        if re.search(r'.*No\s+results\s+for\s+search.*', repo_status_url, re.MULTILINE):
            repo_status_number = '0'
        else:
            repo_status_number = re.findall(r'.*of\s+(\d+)\s+results*.*', repo_status_url, re.MULTILINE)[0]
        #print '''%s in %s: %s''' % (status, repo, repo_status_number)
        data.append(repo_status_number)

    for importance in ('Undecided', 'Wishlist', 'Low', 'Medium', 'High', 'Critical'):
        repo_importance_url = urllib.urlopen('''%s&field.importance:list=%s''' % (importance_url, importance) ).read()
        if re.search(r'.*No\s+results\s+for\s+search.*', repo_importance_url, re.MULTILINE):
	    repo_importance_number = '0'
        else:
    	    repo_importance_number = re.findall(r'.*of\s+(\d+)\s+results*.*', repo_importance_url, re.MULTILINE)[0]
        #print '''%s in %s: %s''' % (importance, repo, repo_importance_number)
        data.append(repo_importance_number)
# debugging
#    print 'repo is %s' % (repo)
#    print ', '.join(data)
    datafile.write(', '.join(data))
    datafile.write("\n")
    datafile.close()
