#!/usr/bin/python

from glob import glob

import simplejson as json


def load_existing_stats(ps_stats_filename):
    try:
        ps_stats_file = open(ps_stats_filename, 'r')
    except IOError:
        return
    json_data = json.load(ps_stats_file)
    ps_stats_file.close()

    for record in json_data['records']:
        records.append(record)

def write_table_header():
    header = "||"
    columns = ['Package Set', 'Critical', 'High', 'Medium', 'Low',
               'Undecided', 'Wishlist']
    for column in columns:
        header += " "
        header += column
        header += " ||"
    header += "\n"
    moin_file.write(header)

def write_table_row(data):
    keys = ['critical', 'high', 'medium', 'low', 'undecided', 'wishlist']
    row = "||"
    row += " %s ||" % ps_pkg_name
    for key in keys:
        row += " "
        row += "%s" % data[key]
        row += " ||"
    row += "\n"
    moin_file.write(row)

records = []
moin_file = open("packagesets-stats.moinmoin", "w")

write_table_header()

for package_set in glob("*-packageset-packages.txt"):
    ps_stats_filename = "%s-bug-stats.json" % \
                        (package_set.replace('-packages.txt',''))
    ps_pkg_name = "%s" % \
                  (package_set.replace('-packageset-packages.txt','').title())
    load_existing_stats(ps_stats_filename)

    write_table_row(records[-1])

moin_file.close()
