#!/usr/bin/python

import simplejson as json
import sys


def get_csv_data(package):
    datafile = open("%s/%s.data" % (package, package), 'r')
    for line in datafile:
        if line.startswith('#'):
            continue
        stats = line.split(',')
        time = int(stats[0])
        new = int(stats[2])
        incomplete = int(stats[3])
        confirmed = int(stats[4])
        triaged = int(stats[5])
        inprogress = int(stats[6])
        fixcommitted = int(stats[7])
        fixreleased = int(stats[8])
        invalid = int(stats[9])
        wontfix = int(stats[10])
        undecided = int(stats[11])
        wishlist = int(stats[12])
        low = int(stats[13])
        medium = int(stats[14])
        high = int(stats[15])
        critical = int(stats[16])

        records.append({
                        'date': time,
                        'new': new,
                        'incomplete': incomplete,
                        'confirmed': confirmed,
                        'triaged': triaged,
                        'inprogress': inprogress,
                        'fixcommitted': fixcommitted,
                        'fixreleased': fixreleased,
                        'invalid': invalid,
                        'wontfix': wontfix,
                        'undecided': undecided,
                        'wishlist': wishlist,
                        'low': low,
                        'medium': medium,
                        'high': high,
                        'critical': critical
                      })

    datafile.close()

ps_pkg_filename = sys.argv[1]
ps_pkg_file = open(ps_pkg_filename, 'r')

records = []
for line in ps_pkg_file:
    line = line.strip("\n")
    pkg_stats_filename = "%s/%s-bug-stats.json" % (line, line)
    get_csv_data(line)

    report = {
              'keys': ['date', 'new', 'incomplete', 'confirmed', 'triaged',
                       'inprogress', 'fixcommitted', 'fixreleased', 'invalid',
                       'wontfix', 'undecided', 'wishlist', 'low', 'medium', 
                       'high', 'critical'],
              'records': records}

    pkg_stats_file = open(pkg_stats_filename, 'w')
    pkg_stats_file.write(json.dumps(report))
    pkg_stats_file.close()
