#!/usr/bin/python

import simplejson as json
import sys


def load_existing_stats(pkg_stats_filename):
    try:
        pkg_stats_file = open(pkg_stats_filename, 'r')
    except IOError:
        return None
    json_data = json.load(pkg_stats_file)
    pkg_stats_file.close()

    return json_data['records'][-1]


def write_table_header():
    header = "||"
    columns = ['Package', 'Critical', 'High', 'Medium', 'Low',
               'Undecided', 'Wishlist']
    for column in columns:
        header += " "
        header += column
        header += " ||"
    header += "\n"
    moin_file.write(header)


def write_table_row(data):
    keys = ['critical', 'high', 'medium', 'low', 'undecided', 'wishlist']
    row = "||"
    row += " %s ||" % pkg_name
    for key in keys:
        row += " "
        row += "%s" % data[key]
        row += " ||"
    row += "\n"
    moin_file.write(row)

packageset_filename = sys.argv[1]
packageset_file = open(packageset_filename, 'r')
packageset_moinname = '%s' % packageset_filename.replace('s.txt',
                                                         '-stats.moin')

moin_file = open(packageset_moinname, 'w')

write_table_header()

for line in packageset_file:
    records = []
    pkg_name = line.strip('\n')
    pkg_stats_filename = '%s/%s-bug-stats.json' % (pkg_name, pkg_name)
    pkg_data = load_existing_stats(pkg_stats_filename)
    if pkg_data:
        records.append(pkg_data)
        write_table_row(records[-1])
    else:
        continue

moin_file.close()
