#!/usr/bin/python
# Author: Brian Murray <brian@canonical.com>
# Copyright (C) 2010 Canonical, Ltd.
# License: GPLv3

from sys import argv
import lpl_common

lp = lpl_common.connect(use_edge=False,version='devel')

ubuntu = lp.distributions['ubuntu']
dev_release = ubuntu.current_series

package_sets = [ps.name for ps in lp.packagesets if ps.distroseries==dev_release]

for package_set in package_sets:
    packages = lp.packagesets.getByName(distroseries=dev_release,
                                        name=package_set).getSourcesIncluded()
    filename = "%s-packageset-packages.txt" % package_set
    datafile= open(filename, "w")

    for package in packages:
        datafile.write("%s\n" % package)

    datafile.close()
